<%@ Page Language="VB" %>
<%@ import Namespace="System.Drawing" %>
<%@ import Namespace="System.Drawing.Text" %>
<%@ import Namespace="System.Drawing.Imaging" %>
<%@ import Namespace="System.Drawing.Drawing2D" %>
<%@ import Namespace="System.Security.Cryptography" %>
<%@ import Namespace="System.Runtime.Serialization.Formatters.Binary" %>
<%@ import Namespace="System.IO" %>

<script runat="server">
'REMEMBER: To check all functions using an image file (brush, drawimage)

Public q As Hashtable = new HashTable()
Public brushSharedRect As Rectangle
Public i As Integer

Sub LoadUpq 'Load up hashtable with commands from a source like Session
If Not Session("ImageEditorCommands") Is Nothing Then
q = Session("ImageEditorCommands")
'Session("ImageEditorCommands") = Nothing
Else
q.Add("Init", "Width=200,Height=200,PixelFormat=9,TextRenderingHint=4,CompositingMode=0," _
& "CompositingQuality=3,SmoothingMode=2,InterpolationMode=2,PixelOffsetMode=0,fFormat=jpg," _
& "bgBrush:bType=2,bFColor=#555555,bBColor=#777777,bStyle=20,bFOpac=255,bBOpac=255,:bgBrush")
q.Add("Act1", "DoNothing:")
End If
End Sub

Sub Page_Load
Try
	LoadUpq
	
	Dim strInit As String = q.Item("Init")
	'Making Variables from strInit
	Dim width As Integer = strInit.substring( strInit.IndexOf("Width")+6, (strInit.IndexOf(",", strInit.IndexOf("Width")) - strInit.IndexOf("=", strInit.IndexOf("Width")) ) )
	Dim height As Integer = strInit.substring( strInit.IndexOf("Height")+7, (strInit.IndexOf(",", strInit.IndexOf("Height")) - strInit.IndexOf("=", strInit.IndexOf("Height")) ) )
	Dim fPixelFormat As Integer = strInit.substring( strInit.IndexOf("PixelFormat")+12, (strInit.IndexOf(",", strInit.IndexOf("PixelFormat")) - strInit.IndexOf("=", strInit.IndexOf("PixelFormat")) ) )
	Dim fTextRenderingHint As Integer = strInit.substring( strInit.IndexOf("TextRenderingHint")+18, (strInit.IndexOf(",", strInit.IndexOf("TextRenderingHint")) - strInit.IndexOf("=", strInit.IndexOf("TextRenderingHint")) ) )
	Dim fCompositingMode As Integer = strInit.substring( strInit.IndexOf("CompositingMode")+16, (strInit.IndexOf(",", strInit.IndexOf("CompositingMode")) - strInit.IndexOf("=", strInit.IndexOf("CompositingMode")) ) )
	Dim fCompositingQuality As Integer = strInit.substring( strInit.IndexOf("CompositingQuality")+19, (strInit.IndexOf(",", strInit.IndexOf("CompositingQuality")) - strInit.IndexOf("=", strInit.IndexOf("CompositingQuality")) ) )
	Dim fSmoothingMode As Integer = strInit.substring( strInit.IndexOf("SmoothingMode")+14, (strInit.IndexOf(",", strInit.IndexOf("SmoothingMode")) - strInit.IndexOf("=", strInit.IndexOf("SmoothingMode")) ) )
	Dim fInterpolationMode As Integer = strInit.substring( strInit.IndexOf("InterpolationMode")+18, (strInit.IndexOf(",", strInit.IndexOf("InterpolationMode")) - strInit.IndexOf("=", strInit.IndexOf("InterpolationMode")) ) )
	Dim fPixelOffsetMode As Integer = strInit.substring( strInit.IndexOf("PixelOffsetMode")+16, (strInit.IndexOf(",", strInit.IndexOf("PixelOffsetMode")) - strInit.IndexOf("=", strInit.IndexOf("PixelOffsetMode")) ) )
	Dim bgstrB As String = strInit.substring( strInit.IndexOf("bgBrush:")+9, (strInit.IndexOf(":bgBrush", strInit.IndexOf("bgBrush:")+9) - strInit.IndexOf(":", strInit.IndexOf("bgBrush:")) - 1 ) )
	Dim fFormat As String = strInit.substring( strInit.IndexOf("fFormat")+8, (strInit.IndexOf(",", strInit.IndexOf("fFormat")) - strInit.IndexOf("=", strInit.IndexOf("fFormat")) -1 ) )
	'Create graphics and bitmap objects and define properties
	Dim bmp As new Bitmap(width, height)
	Dim g as Graphics = Graphics.FromImage(bmp)
	g.TextRenderingHint = fTextRenderingHint
	g.CompositingMode = fCompositingMode
	g.CompositingQuality = fCompositingQuality
	g.SmoothingMode = fSmoothingMode
	g.InterpolationMode = fInterpolationMode
	g.PixelOffsetMode = fPixelOffsetMode
	brushSharedRect.Width = width
	brushSharedRect.Height = height
	g.FillRectangle(GetBrush(bgstrB), new Rectangle(0,0,width,height)) 'Background
				'Disposing
				width = Nothing
				height = Nothing
				fPixelFormat = Nothing
				fTextRenderingHint = Nothing
				fCompositingMode = Nothing
				fCompositingQuality = Nothing
				fSmoothingMode = Nothing
				fInterpolationMode = Nothing
				fPixelOffsetMode = Nothing
				bgstrB = Nothing
	For i = 1 To (q.Count - 1) 'Start processing the Acts
	If q.ContainsKey("Act" & i) Then
	Select Case CStr(q.Item("Act" & i)).substring(0, CStr(q.Item("Act" & i)).indexOf(":"))
		'Writing Text-----------------------------------------------------------------------------
		Case "WriteText"
			Dim ffTxt As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Txt")+4, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Txt")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Txt")) - 1 ) )
			Dim ffFamily As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("FontFamily")+11, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("FontFamily")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("FontFamily")) - 1 ) )
			Dim ffSize As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("FontSize")+9, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("FontSize")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("FontSize")) ) )
			Dim ffStyle As FontStyle = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("FontStyle")+10, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("FontStyle")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("FontStyle")) ) )
			Dim ffX As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("X")+2, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("X")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("X")) ) )
			Dim ffY As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Y")+2, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Y")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Y")) ) )
			Dim Outline As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Outline")+8, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Outline")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Outline")) ) )
			Dim ffOutlineColor As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("OutlineColor")+13, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("OutlineColor")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("OutlineColor")) - 1 ) )
			Dim Opacity As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Opacity")+8, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Opacity")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Opacity")) ) )
			Dim ffShadowLevels As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("ShadowLevels")+13, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("ShadowLevels")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("ShadowLevels")) ) )
			Dim ffShadowColor As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("ShadowColor")+12, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("ShadowColor")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("ShadowColor")) - 1 ) )
			Dim ffShadowOrientation As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("ShadowOrientation")+18, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("ShadowOrientation")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("ShadowOrientation")) - 1 ) )
			Dim ffstrB As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Brush:")+7, (CStr(q.Item("Act" & i)).IndexOf(":Brush", CStr(q.Item("Act" & i)).IndexOf("Brush:")+7) - CStr(q.Item("Act" & i)).IndexOf(":", CStr(q.Item("Act" & i)).IndexOf("Brush:")) - 1 ) )
				Dim fFont As New Font(ffFamily, ffSize, ffStyle)
              	Dim TextSize As SizeF
              	TextSize = g.MeasureString(ffTxt, fFont)
				brushSharedRect = New Rectangle(ffX, ffY, TextSize.width, TextSize.height)
				Dim fBrush
				fBrush = GetBrush(ffstrB, Opacity)
				'Draw Outlines
				If Not Outline = 0 Then
				Dim oBrush As New SolidBrush(Hex2Rgb(ffOutlineColor, Opacity))
					Dim ii As Integer
					For ii = 0 to Outline
						g.DrawString(ffTxt, fFont, oBrush, new PointF(ffX - ii, ffY - ii))
						g.DrawString(ffTxt, fFont, oBrush, new PointF(ffX + ii, ffY - ii))
						g.DrawString(ffTxt, fFont, oBrush, new PointF(ffX - ii, ffY + ii))
						g.DrawString(ffTxt, fFont, oBrush, new PointF(ffX + ii, ffY + ii))
					Next
					ii = Nothing
				End If
				'Draw Shadow
				If Not ffShadowLevels = 0 Then
				Dim ii, nX, nY
				For ii = 0 to ffShadowLevels
					nX = GetShadowPoint(ffX,ffY,ii,ffShadowOrientation).X
					nY = GetShadowPoint(ffX,ffY,ii,ffShadowOrientation).Y
					g.DrawString(ffTxt, fFont, new SolidBrush(Hex2Rgb(ffShadowColor, (Opacity / ffShadowLevels) * (ffShadowLevels - ii) ) ), new PointF(nX, nY))
				Next
				ii = Nothing
				nX = Nothing
				nY = Nothing
				End If
			'Draw At last String
			g.DrawString(ffTxt, fFont, fBrush, new PointF(ffX, ffY))
					'Disposing
					fBrush = Nothing
					TextSize = Nothing
					fFont = Nothing
					ffstrB = Nothing
					ffShadowOrientation = Nothing
					ffShadowColor = Nothing
					ffShadowLevels = Nothing
					Opacity = Nothing
					ffOutlineColor = Nothing
					Outline = Nothing
					ffY = Nothing
					ffX = Nothing
					ffStyle = Nothing
					ffSize = Nothing
					ffFamily = Nothing
					ffTxt = Nothing
			'DRAW IMAGE --------------------------------------------------------------------------
		Case "DrawImage"
			Dim ImagePath As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("ImagePath")+10, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("ImagePath")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("ImagePath")) - 1 ) )
			Dim imgWidth As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Width")+6, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Width")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Width")) ) )
			Dim imgHeight As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Height")+7, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Height")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Height")) ) )
			Dim imgX As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("X")+2, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("X")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("X")) ) )
			Dim imgY As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Y")+2, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Y")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Y")) ) )
				Dim Image2Draw As System.Drawing.Image = System.Drawing.Image.FromFile(Server.MapPath(ImagePath), True)
				If Not imgWidth = 0 Then
					g.DrawImage(Image2Draw, imgX, imgY, imgWidth, imgHeight)
				Else
					g.DrawImage(Image2Draw, imgX, imgY)
				End If
				'Disposing
				ImagePath = Nothing
				imgWidth = Nothing
				imgHeight = Nothing
				imgX = Nothing
				imgY = Nothing
				Image2Draw = Nothing
			'DRAW PATH --------------------------------------------------------------------------
		Case "DrawPath"
			Dim Opacity As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Opacity")+8, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Opacity")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Opacity")) ) )
			Dim strBrush As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Brush:")+7, (CStr(q.Item("Act" & i)).IndexOf(":Brush", CStr(q.Item("Act" & i)).IndexOf("Brush:")+7) - CStr(q.Item("Act" & i)).IndexOf(":", CStr(q.Item("Act" & i)).IndexOf("Brush:")) - 1 ) )
			Dim ffShadowLevels As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("ShadowLevels")+13, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("ShadowLevels")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("ShadowLevels")) ) )
			Dim ffShadowColor As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("ShadowColor")+12, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("ShadowColor")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("ShadowColor")) - 1 ) )
			Dim ffShadowOrientation As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("ShadowOrientation")+18, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("ShadowOrientation")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("ShadowOrientation")) - 1 ) )
			Dim IsFilled As Boolean = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Fill")+5, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Fill")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Fill")) - 1 ) )
			Dim PenColor As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("PenColor")+9, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("PenColor")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("PenColor")) - 1 ) )
			Dim PenWidth As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("PenWidth")+9, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("PenWidth")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("PenWidth")) ) )
			Dim oFillMode As Integer = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("FillMode")+9, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("FillMode")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("FillMode")) ) )
			Dim Points As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Points")+7, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Points")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Points")) - 1 ) )
			Dim Types As String = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Types")+6, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Types")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Types")) - 1 ) )
			Dim IsBlurred As Boolean = CStr(q.Item("Act" & i)).substring( CStr(q.Item("Act" & i)).IndexOf("Blur")+5, (CStr(q.Item("Act" & i)).IndexOf(",", CStr(q.Item("Act" & i)).IndexOf("Blur")) - CStr(q.Item("Act" & i)).IndexOf("=", CStr(q.Item("Act" & i)).IndexOf("Blur")) - 1 ) )
					
				Dim ppoints() As PointF = GetDeSerializedObj(Points)
				Dim ttypes() As Byte = GetDeSerializedObj(Types)
				Dim nn As Object = new GraphicsPath(ppoints, ttypes, oFillMode)
				
				brushSharedRect = Rectangle.Round(nn.GetBounds)
				
				'Draw Shadow
				If Not ffShadowLevels = 0 Then
				Dim ii, nX, nY, nP, nM
				nP = nn.Clone()
				nM = new Matrix()
				For ii = 0 to ffShadowLevels
					nM.Reset()
					If Not IsBlurred Then
					nP = nn.Clone()
					End If
					nM.Translate(GetShadowPoint(0,0,ii,ffShadowOrientation).X,GetShadowPoint(0,0,ii,ffShadowOrientation).Y)
					nP.Transform(nM)
					'nX = GetShadowPoint(ffX,ffY,ii,ffShadowOrientation).X
					'nY = GetShadowPoint(ffX,ffY,ii,ffShadowOrientation).Y
					g.DrawPath(new Pen(Hex2Rgb(ffShadowColor, (Opacity / ffShadowLevels) * (ffShadowLevels - ii) ), CSng(PenWidth)), nP)
				Next
				nM = Nothing
				nP = Nothing
				ii = Nothing
				nX = Nothing
				nY = Nothing
				End If
				
				If Not PenWidth = 0 Then
				g.DrawPath(new Pen(Hex2Rgb(PenColor, Opacity), CSng(PenWidth)), nn)
				End If
				If IsFilled Then
				g.FillPath(GetBrush(strBrush, Opacity), nn)
				End If
				'Disposing
				IsBlurred = Nothing
				Opacity = Nothing
				strBrush = Nothing
				ffShadowLevels = Nothing
				ffShadowColor = Nothing
				ffShadowOrientation = Nothing
				IsFilled = Nothing
				PenColor = Nothing
				PenWidth = Nothing
				oFillMode = Nothing
				Points = Nothing
				Types = Nothing
	End Select
	End If
	Next
						
	'Finally save the Image to the output stream for the user to see
	Select Case fFormat
		Case "gif"
		Response.ContentType = "image/gif"
		bmp.Save(Response.OutputStream, ImageFormat.gif)
		Case Else
		Response.ContentType = "image/jpeg"
		bmp.Save(Response.OutputStream, ImageFormat.Jpeg)
	End Select
	g.Dispose( )
	bmp.Dispose( )
				'Disposing
				strInit = Nothing
				fFormat = Nothing
				i = Nothing
				q = Nothing
				brushSharedRect = Nothing
Catch
	Dim bmp As new Bitmap(50, 50)
	Dim g as Graphics = Graphics.FromImage(bmp)

	g.FillRectangle(new HatchBrush(27, Color.DarkBlue, Color.Gray), new Rectangle(0,0,50,50))
	Dim strFormat As New StringFormat()
	strFormat.Alignment = StringAlignment.Center
	strFormat.LineAlignment = StringAlignment.Center
	g.DrawString("Error",new Font(new FontFamily("Arial"), 10, FontStyle.Bold), new SolidBrush(Color.White), new RectangleF(0,0,50,50), strFormat)
	
	Response.ContentType = "image/jpeg"
	bmp.Save(Response.OutputStream, ImageFormat.Jpeg)
End Try
End Sub
'EXITING SUB
'Return coordinates that accord to shadow's direction
Function GetShadowPoint (ByVal stX As Integer, ByVal stY As Integer, ByVal sti As Integer, ByVal ShadDir As String) As Point
							Select Case ShadDir
								Case "BottomLeft"
									return new Point(( stX - sti ), ( stY + sti ))
								Case "Bottom"
									return new Point(( stX ), ( stY + sti ))
								Case "BottomRight"
									return new Point(( stX + sti ), ( stY + sti ))
								Case "Right"
									return new Point(( stX + sti ), ( stY ))
								Case "UpperRight"
									return new Point(( stX + sti ), ( stY - sti ))
								Case "Upper"
									return new Point(( stX ), ( stY - sti ))
								Case "UpperLeft"
									return new Point(( stX - sti ), ( stY - sti ))
								Case "Left"
									return new Point(( stX - sti ), ( stY ))
							End Select
End Function
'Create brushes (texture, gradient, solid, hatch)
Function GetBrush (ByVal strB As String, Optional ByVal Opac As Integer = 255)
	Dim bType As Integer = strB.substring( strB.IndexOf("bType")+6, 1 )
	Select Case bType
	Case 1 'Gradient
		Dim bGradFirst As String = strB.substring( strB.IndexOf("bGradFirst")+11, strB.IndexOf(",", strB.IndexOf("bGradFirst")) - strB.IndexOf("=", strB.IndexOf("bGradFirst")) - 1)
		Dim bGradLast As String = strB.substring( strB.IndexOf("bGradLast")+10, strB.IndexOf(",", strB.IndexOf("bGradLast")) - strB.IndexOf("=", strB.IndexOf("bGradLast")) - 1)
		Dim bGradAngle As Integer = strB.substring( strB.IndexOf("bGradAngle")+11, (strB.IndexOf(",", strB.IndexOf("bGradAngle")) - strB.IndexOf("=", strB.IndexOf("bGradAngle")) ) )
		Dim bOpacFirst As Integer = strB.substring( strB.IndexOf("bOpacFirst")+11, (strB.IndexOf(",", strB.IndexOf("bOpacFirst")) - strB.IndexOf("=", strB.IndexOf("bOpacFirst")) ) )
		Dim bOpacLast As Integer = strB.substring( strB.IndexOf("bOpacLast")+10, (strB.IndexOf(",", strB.IndexOf("bOpacLast")) - strB.IndexOf("=", strB.IndexOf("bOpacLast")) ) )
		return new LinearGradientBrush(brushSharedRect, Hex2Rgb(bGradFirst, bOpacFirst), Hex2Rgb(bGradLast, bOpacLast), bGradAngle)
				'Disposing
				bGradFirst = Nothing
				bGradLast = Nothing
				bGradAngle = Nothing
				bOpacFirst = Nothing
				bOpacLast = Nothing
	Case 0 'Solid
		Dim bColor As String = strB.substring( strB.IndexOf("bColor")+7, strB.IndexOf(",", strB.IndexOf("bColor")) - strB.IndexOf("=", strB.IndexOf("bColor")) - 1)
		return new SolidBrush(Hex2Rgb(bColor, Opac))
				'Disposing
				bColor = Nothing
	Case 2 'Hatch
		Dim bFColor As String = strB.substring( strB.IndexOf("bFColor")+8, strB.IndexOf(",", strB.IndexOf("bFColor")) - strB.IndexOf("=", strB.IndexOf("bFColor")) - 1)
		Dim bBColor As String = strB.substring( strB.IndexOf("bBColor")+8, strB.IndexOf(",", strB.IndexOf("bBColor")) - strB.IndexOf("=", strB.IndexOf("bBColor")) - 1)
		Dim bStyle As Integer = strB.substring( strB.IndexOf("bStyle")+7, (strB.IndexOf(",", strB.IndexOf("bStyle")) - strB.IndexOf("=", strB.IndexOf("bStyle")) ) )
		Dim bFOpac As Integer = strB.substring( strB.IndexOf("bFOpac")+7, (strB.IndexOf(",", strB.IndexOf("bFOpac")) - strB.IndexOf("=", strB.IndexOf("bFOpac")) ) )
		Dim bBOpac As Integer = strB.substring( strB.IndexOf("bBOpac")+7, (strB.IndexOf(",", strB.IndexOf("bBOpac")) - strB.IndexOf("=", strB.IndexOf("bBOpac")) ) )
		return new HatchBrush(bStyle, Hex2Rgb(bFColor, bFOpac), Hex2Rgb(bBColor, bBOpac))
				'Disposing
				bFColor = Nothing
				bBColor = Nothing
				bStyle = Nothing
				bFOpac = Nothing
				bBOpac = Nothing
	Case 3 'Texture
		Dim bWrapStyle As Integer = strB.substring( strB.IndexOf("bWrapStyle")+11, (strB.IndexOf(",", strB.IndexOf("bWrapStyle")) - strB.IndexOf("=", strB.IndexOf("bWrapStyle")) ) )
		Dim bImagePath As String = strB.substring( strB.IndexOf("bImagePath")+11, strB.IndexOf(",", strB.IndexOf("bImagePath")) - strB.IndexOf("=", strB.IndexOf("bImagePath")) - 1)
		Dim TxtImg As System.Drawing.Image = System.Drawing.Image.FromFile(Server.MapPath(bImagePath), True)
		return new TextureBrush(TxtImg, bWrapStyle, brushSharedRect)
				'Disposing
				bWrapStyle = Nothing
				bImagePath = Nothing
				TxtImg = Nothing
	End Select
End Function
'Decodign Hex Color String to ARGB color class
Function Hex2Rgb (ByVal HexStr As String, Optional ByVal oAlpha As Integer = 255) As Color
HexStr = HexStr.Replace("#", "")
Dim rred As Integer
Dim ggreen As Integer
Dim bblue As Integer
	rred = CInt(DemVal(HexStr.substring(0,1)) * 16 + DemVal(HexStr.substring(1,1)))
	ggreen = CInt(DemVal(HexStr.substring(2,1)) * 16 + DemVal(HexStr.substring(3,1)))
	bblue = CInt(DemVal(HexStr.substring(4,1)) * 16 + DemVal(HexStr.substring(5,1)))
return Color.FromArgb(oAlpha, rred, ggreen, bblue)
				'Disposing
				rred = Nothing
				ggreen = Nothing
				bblue = Nothing
End Function
Function DemVal (ByVal HexChar As String) As Integer
	Select Case LCase(HexChar)
	Case "a"
		return 10
	Case "b"
		return 11
	Case "c"
		return 12
	Case "d"
		return 13
	Case "e"
		return 14
	Case "f"
		return 15
	Case Else
		return CInt(HexChar)
	End Select
End Function

	Public Function GetSerializedStr(ByVal obj2Serial As Object) As String
		Dim objBinaryFormatterC As BinaryFormatter
		objBinaryFormatterC = New BinaryFormatter
		Dim MemoryStreamC
		MemoryStreamC = New MemoryStream
		objBinaryFormatterC.Serialize(MemoryStreamC, obj2Serial)
		Dim ArrayByteC() As Byte
		ArrayByteC = MemoryStreamC.ToArray()
		Dim TTS As String
		Dim TempCB As Byte
			For Each TempCB In ArrayByteC
				TTS = TTS & "-" & TempCB
			Next TempCB
		MemoryStreamC.Close()
		'Replace all 1 with {
		Dim TTS2 As String = TTS.Replace("1", "{")
		'Replace all 5 with >
		TTS2 = TTS2.Replace("5", ">")
		'Replace all 49 with *
		TTS2 = TTS2.Replace("49", "*")
		'Replace all {{ with $
		TTS2 = TTS2.Replace("{{", "$")
		'Replace all >> with <
		TTS2 = TTS2.Replace(">>", "<")
		'Replace all -0- with ]
		TTS2 = TTS2.Replace("-0-", "]")
		'Replace all -{ with @
		TTS2 = TTS2.Replace("-{", "@")
		'Replace all -$ with underscore
		TTS2 = TTS2.Replace("-$", "_")
		'Replace all 08 with +
		TTS2 = TTS2.Replace("08", "+")
		'Replace all 00 with ,
		TTS2 = TTS2.Replace("00", ".")
		'Replace all -*- with %
		TTS2 = TTS2.Replace("-*-", "%")
		'Replace all 0] with ^
		TTS2 = TTS2.Replace("0]", "^")
		
		Return TTS2
					objBinaryFormatterC = Nothing
			MemoryStreamC = Nothing
			ArrayByteC = Nothing
			TTS = Nothing
			TempCB = Nothing
			TTS2 = Nothing
	End Function
	
	'Function to get the object back through a string returned by GetSerializedStr()
	
	Public Function GetDeSerializedObj(ByVal strSerialized As String) As Object
			Dim SobjBinaryFormatterC As BinaryFormatter
			SobjBinaryFormatterC = New BinaryFormatter
			Dim SMemoryStreamC
			SMemoryStreamC = New MemoryStream
			Dim STT As String = strSerialized.Replace("^", "0]")
			STT = STT.Replace("%", "-*-")
			STT = STT.Replace(".", "00")
			STT = STT.Replace("+", "08")
			STT = STT.Replace("_", "-$")
			STT = STT.Replace("@", "-{")
			STT = STT.Replace("]", "-0-")
			STT = STT.Replace("<", ">>")
			STT = STT.Replace("$", "{{")
			STT = STT.Replace("*", "49")
			STT = STT.Replace(">", "5")
			STT = STT.Replace("{", "1")
			Dim STempCB As String
			Dim SArrayByte
			SArrayByte = New ArrayList
			Dim SContinue As Boolean = True
			Dim SPosition As Integer = 0
			Dim SCounterB As Integer = 0
			Dim PtempP As Integer
			Dim PPtempPP
			
			Do While SContinue
			If Not SPosition = -1 Then
			If Not STT.indexOf("-", SPosition + 1) = -1 Then
			PPtempPP = STT.indexOf("-", SPosition + 1) -1
			STempCB = STT.substring(SPosition + 1, PPtempPP - SPosition)
			SArrayByte.Insert(SCounterB, CByte(STempCB))
			Else
			PtempP = STT.length - 1
			STempCB = STT.substring(SPosition + 1, PtempP - SPosition)
			SArrayByte.Insert(SCounterB, CByte(STempCB))
			SContinue = False
			End If
			Else
			SContinue = False
			End If
			SPosition = STT.indexOf("-", SPosition + 1)
			SCounterB = SCounterB + 1
			Loop
			
			Dim SCounter As Integer = 0
			Dim SArrayByte2
			SArrayByte2 = SArrayByte.ToArray()
			Do
			SMemoryStreamC.WriteByte(SArrayByte2(SCounter))
			SCounter = SCounter + 1
			Loop Until SCounter = SArrayByte2.Length
					Dim SObj2get
					SMemoryStreamC.Position = 0
					SObj2get = SobjBinaryFormatterC.Deserialize(SMemoryStreamC)
			SMemoryStreamC.Close()
			
			Return SObj2get
								SobjBinaryFormatterC = Nothing
					SMemoryStreamC = Nothing
					STT = Nothing
					STempCB = Nothing
					SArrayByte = Nothing
					SContinue = Nothing
					SPosition = Nothing
					SCounterB = Nothing
					PtempP = Nothing
					PPtempPP = Nothing
					SCounter = Nothing
					SArrayByte2 = Nothing
	End Function
</script>